Index: uspace/lib/nettl/src/portrng.c
===================================================================
--- uspace/lib/nettl/src/portrng.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
+++ uspace/lib/nettl/src/portrng.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -0,0 +1,169 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnettl
+ * @{
+ */
+
+/**
+ * @file Port range allocator
+ *
+ * Allocates port numbers from IETF port number ranges.
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <inet/endpoint.h>
+#include <nettl/portrng.h>
+#include <stdint.h>
+#include <stdlib.h>
+
+#include <io/log.h>
+
+int portrng_create(portrng_t **rpr)
+{
+	portrng_t *pr;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_create() - begin");
+
+	pr = calloc(1, sizeof(portrng_t));
+	if (pr == NULL)
+		return ENOMEM;
+
+	list_initialize(&pr->used);
+	*rpr = pr;
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_create() - end");
+	return EOK;
+}
+
+void portrng_destroy(portrng_t *pr)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_destroy()");
+	assert(list_empty(&pr->used));
+	free(pr);
+}
+
+int portrng_alloc(portrng_t *pr, uint16_t pnum, void *arg,
+    portrng_flags_t flags, uint16_t *apnum)
+{
+	portrng_port_t *p;
+	uint32_t i;
+	bool found;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_alloc() - begin");
+
+	if (pnum == inet_port_any) {
+
+		for (i = inet_port_dyn_lo; i <= inet_port_dyn_hi; i++) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG2, "trying %" PRIu32, i);
+			found = false;
+			list_foreach(pr->used, lprng, portrng_port_t, port) {
+				if (port->pn == pnum) {
+					found = true;
+					break;
+				}
+			}
+
+			if (!found) {
+				pnum = i;
+				break;
+			}
+		}
+
+		if (pnum == inet_port_any) {
+			/* No free port found */
+			return ENOENT;
+		}
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "selected %" PRIu16, pnum);
+	} else {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "user asked for %" PRIu16, pnum);
+
+		if ((flags & pf_allow_system) == 0 &&
+		    pnum < inet_port_user_lo) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG2, "system port not allowed");
+			return EINVAL;
+		}
+
+		list_foreach(pr->used, lprng, portrng_port_t, port) {
+			if (port->pn == pnum) {
+				log_msg(LOG_DEFAULT, LVL_DEBUG2, "port already used");
+				return EEXISTS;
+			}
+		}
+	}
+
+	p = calloc(1, sizeof(portrng_port_t));
+	if (p == NULL)
+		return ENOMEM;
+
+	p->pn = pnum;
+	p->arg = arg;
+	list_append(&p->lprng, &pr->used);
+	*apnum = pnum;
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_alloc() - end OK pn=%" PRIu16,
+	    pnum);
+	return EOK;
+}
+
+int portrng_find_port(portrng_t *pr, uint16_t pnum, void **rarg)
+{
+	list_foreach(pr->used, lprng, portrng_port_t, port) {
+		if (port->pn == pnum) {
+			*rarg = port->arg;
+			return EOK;
+		}
+	}
+
+	return ENOENT;
+}
+
+void portrng_free_port(portrng_t *pr, uint16_t pnum)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port() - begin");
+	list_foreach(pr->used, lprng, portrng_port_t, port) {
+		if (port->pn == pnum) {
+			list_remove(&port->lprng);
+			free(port);
+			return;
+		}
+	}
+
+	assert(false);
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port() - end");
+}
+
+bool portrng_empty(portrng_t *pr)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_empty()");
+	return list_empty(&pr->used);
+}
+
+/**
+ * @}
+ */
+
Index: uspace/lib/pcut/src/run.c
===================================================================
--- uspace/lib/pcut/src/run.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/pcut/src/run.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -73,8 +73,9 @@
 static int default_suite_initialized = 0;
 
-static void init_default_suite_when_needed() {
-	if (default_suite_initialized) {
+static void init_default_suite_when_needed(void)
+{
+	if (default_suite_initialized)
 		return;
-	}
+	
 	default_suite.id = -1;
 	default_suite.kind = PCUT_KIND_TESTSUITE;
@@ -91,11 +92,13 @@
  * @return Always a valid test suite item.
  */
-static pcut_item_t *pcut_find_parent_suite(pcut_item_t *it) {
+static pcut_item_t *pcut_find_parent_suite(pcut_item_t *it)
+{
 	while (it != NULL) {
-		if (it->kind == PCUT_KIND_TESTSUITE) {
+		if (it->kind == PCUT_KIND_TESTSUITE)
 			return it;
-		}
+		
 		it = it->previous;
 	}
+	
 	init_default_suite_when_needed();
 	return &default_suite;
@@ -106,8 +109,8 @@
  * @param func Function to run (can be NULL).
  */
-static void run_setup_teardown(pcut_setup_func_t func) {
-	if (func != NULL) {
+static void run_setup_teardown(pcut_setup_func_t func)
+{
+	if (func != NULL)
 		func();
-	}
 }
 
@@ -119,11 +122,11 @@
  * @param outcome Outcome of the current test.
  */
-static void leave_test(int outcome) {
+static void leave_test(int outcome)
+{
 	PCUT_DEBUG("leave_test(outcome=%d), will_exit=%s", outcome,
-		leave_means_exit ? "yes" : "no");
-	if (leave_means_exit) {
+	    leave_means_exit ? "yes" : "no");
+	if (leave_means_exit)
 		exit(outcome);
-	}
-
+	
 #ifndef PCUT_NO_LONG_JUMP
 	longjmp(start_test_jump, 1);
@@ -138,6 +141,8 @@
  * @param message Message describing the failure.
  */
-void pcut_failed_assertion(const char *message) {
+void pcut_failed_assertion(const char *message)
+{
 	static const char *prev_message = NULL;
+	
 	/*
 	 * The assertion failed. We need to abort the current test,
@@ -145,13 +150,12 @@
 	 * include running the tear-down routine.
 	 */
-	if (print_test_error) {
+	if (print_test_error)
 		pcut_print_fail_message(message);
-	}
-
+	
 	if (execute_teardown_on_failure) {
 		execute_teardown_on_failure = 0;
 		prev_message = message;
 		run_setup_teardown(current_suite->teardown_func);
-
+		
 		/* Tear-down was okay. */
 		if (report_test_result) {
@@ -165,7 +169,7 @@
 		}
 	}
-
+	
 	prev_message = NULL;
-
+	
 	leave_test(TEST_OUTCOME_FAIL); /* No return. */
 }
@@ -176,5 +180,6 @@
  * @return Error status (zero means success).
  */
-static int run_test(pcut_item_t *test) {
+static int run_test(pcut_item_t *test)
+{
 	/*
 	 * Set here as the returning point in case of test failure.
@@ -182,20 +187,19 @@
 	 * test execution.
 	 */
+	
 #ifndef PCUT_NO_LONG_JUMP
 	int test_finished = setjmp(start_test_jump);
-	if (test_finished) {
+	if (test_finished)
 		return 1;
-	}
 #endif
-
-	if (report_test_result) {
+	
+	if (report_test_result)
 		pcut_report_test_start(test);
-	}
-
+	
 	current_suite = pcut_find_parent_suite(test);
 	current_test = test;
-
+	
 	pcut_hook_before_test(test);
-
+	
 	/*
 	 * If anything goes wrong, execute the tear-down function
@@ -203,10 +207,10 @@
 	 */
 	execute_teardown_on_failure = 1;
-
+	
 	/*
 	 * Run the set-up function.
 	 */
 	run_setup_teardown(current_suite->setup_func);
-
+	
 	/*
 	 * The setup function was performed, it is time to run
@@ -214,5 +218,5 @@
 	 */
 	test->test_func();
-
+	
 	/*
 	 * Finally, run the tear-down function. We need to clear
@@ -221,14 +225,13 @@
 	execute_teardown_on_failure = 0;
 	run_setup_teardown(current_suite->teardown_func);
-
+	
 	/*
 	 * If we got here, it means everything went well with
 	 * this test.
 	 */
-	if (report_test_result) {
+	if (report_test_result)
 		pcut_report_test_done(current_test, TEST_OUTCOME_PASS,
-			NULL, NULL, NULL);
-	}
-
+		    NULL, NULL, NULL);
+	
 	return 0;
 }
@@ -242,16 +245,15 @@
  * @return Error status (zero means success).
  */
-int pcut_run_test_forked(pcut_item_t *test) {
-	int rc;
-
+int pcut_run_test_forked(pcut_item_t *test)
+{
 	report_test_result = 0;
 	print_test_error = 1;
 	leave_means_exit = 1;
-
-	rc = run_test(test);
-
+	
+	int rc = run_test(test);
+	
 	current_test = NULL;
 	current_suite = NULL;
-
+	
 	return rc;
 }
@@ -265,16 +267,15 @@
  * @return Error status (zero means success).
  */
-int pcut_run_test_single(pcut_item_t *test) {
-	int rc;
-
+int pcut_run_test_single(pcut_item_t *test)
+{
 	report_test_result = 1;
 	print_test_error = 0;
 	leave_means_exit = 0;
-
-	rc = run_test(test);
-
+	
+	int rc = run_test(test);
+	
 	current_test = NULL;
 	current_suite = NULL;
-
+	
 	return rc;
 }
@@ -285,16 +286,16 @@
  * @return Timeout in seconds.
  */
-int pcut_get_test_timeout(pcut_item_t *test) {
+int pcut_get_test_timeout(pcut_item_t *test)
+{
 	int timeout = PCUT_DEFAULT_TEST_TIMEOUT;
 	pcut_extra_t *extras = test->extras;
-
-
+	
 	while (extras->type != PCUT_EXTRA_LAST) {
-		if (extras->type == PCUT_EXTRA_TIMEOUT) {
+		if (extras->type == PCUT_EXTRA_TIMEOUT)
 			timeout = extras->timeout;
-		}
+		
 		extras++;
 	}
-
+	
 	return timeout;
 }
Index: uspace/lib/posix/include/posix/errno.h
===================================================================
--- uspace/lib/posix/include/posix/errno.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/posix/include/posix/errno.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -69,12 +69,10 @@
 extern int *__posix_errno(void);
 
-#define __TOP_ERRNO (-NO_DATA)
+#define __TOP_ERRNO (-EAGAIN)
 
 enum {
 	POSIX_E2BIG = __TOP_ERRNO + 1,
 	POSIX_EACCES = __TOP_ERRNO + 2,
-	POSIX_EADDRINUSE = -EADDRINUSE,
 	POSIX_EADDRNOTAVAIL = -EADDRNOTAVAIL,
-	POSIX_EAFNOSUPPORT = -EAFNOSUPPORT,
 	POSIX_EAGAIN = -EAGAIN,
 	POSIX_EALREADY = __TOP_ERRNO + 3,
@@ -88,5 +86,4 @@
 	POSIX_ECONNRESET = __TOP_ERRNO + 9,
 	POSIX_EDEADLK = __TOP_ERRNO + 10,
-	POSIX_EDESTADDRREQ = -EDESTADDRREQ,
 	POSIX_EDOM = __TOP_ERRNO + 11,
 	POSIX_EDQUOT = __TOP_ERRNO + 12,
@@ -97,5 +94,4 @@
 	POSIX_EIDRM = __TOP_ERRNO + 16,
 	POSIX_EILSEQ = __TOP_ERRNO + 17,
-	POSIX_EINPROGRESS = -EINPROGRESS,
 	POSIX_EINTR = -EINTR,
 	POSIX_EINVAL = -EINVAL,
@@ -114,5 +110,4 @@
 	POSIX_ENFILE = __TOP_ERRNO + 25,
 	POSIX_ENOBUFS = __TOP_ERRNO + 26,
-	POSIX_ENODATA = -NO_DATA,
 	POSIX_ENODEV = __TOP_ERRNO + 27,
 	POSIX_ENOENT = -ENOENT,
@@ -127,9 +122,7 @@
 	POSIX_ENOSTR = __TOP_ERRNO + 34,
 	POSIX_ENOSYS = __TOP_ERRNO + 35,
-	POSIX_ENOTCONN = -ENOTCONN,
 	POSIX_ENOTDIR = -ENOTDIR,
 	POSIX_ENOTEMPTY = -ENOTEMPTY,
 	POSIX_ENOTRECOVERABLE = __TOP_ERRNO + 36,
-	POSIX_ENOTSOCK = -ENOTSOCK,
 	POSIX_ENOTSUP = -ENOTSUP,
 	POSIX_ENOTTY = __TOP_ERRNO + 37,
@@ -141,5 +134,4 @@
 	POSIX_EPIPE = __TOP_ERRNO + 41,
 	POSIX_EPROTO = __TOP_ERRNO + 42,
-	POSIX_EPROTONOSUPPORT = -EPROTONOSUPPORT,
 	POSIX_EPROTOTYPE = __TOP_ERRNO + 43,
 	POSIX_ERANGE = -ERANGE,
@@ -153,4 +145,12 @@
 	POSIX_EWOULDBLOCK = __TOP_ERRNO + 51,
 	POSIX_EXDEV = -EXDEV,
+	POSIX_EINPROGRESS = __TOP_ERRNO + 52,
+	POSIX_ENOTSOCK = __TOP_ERRNO + 53,
+	POSIX_EDESTADDRREQ = __TOP_ERRNO + 54,
+	POSIX_EPROTONOSUPPORT = __TOP_ERRNO + 55,
+	POSIX_EAFNOSUPPORT = __TOP_ERRNO + 56,
+	POSIX_EADDRINUSE = __TOP_ERRNO + 57,
+	POSIX_ENOTCONN = __TOP_ERRNO + 58,
+	POSIX_ENODATA = __TOP_ERRNO + 59,
 };
 
Index: uspace/lib/posix/include/posix/stdlib.h
===================================================================
--- uspace/lib/posix/include/posix/stdlib.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/posix/include/posix/stdlib.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -116,7 +116,10 @@
 
 /* Memory Allocation */
-extern void *__POSIX_DEF__(malloc)(size_t size);
-extern void *__POSIX_DEF__(calloc)(size_t nelem, size_t elsize);
-extern void *__POSIX_DEF__(realloc)(void *ptr, size_t size);
+extern void *__POSIX_DEF__(malloc)(size_t size)
+    __attribute__((malloc));
+extern void *__POSIX_DEF__(calloc)(size_t nelem, size_t elsize)
+    __attribute__((malloc));
+extern void *__POSIX_DEF__(realloc)(void *ptr, size_t size)
+    __attribute__((warn_unused_result));
 extern void __POSIX_DEF__(free)(void *ptr);
 
Index: uspace/lib/posix/include/posix/string.h
===================================================================
--- uspace/lib/posix/include/posix/string.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/posix/include/posix/string.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -67,7 +67,10 @@
 /* From mem.h */
 // #define bzero(ptr, len)  memset((ptr), 0, (len))
-extern void *memset(void *, int, size_t);
-extern void *memcpy(void *, const void *, size_t);
-extern void *memmove(void *, const void *, size_t);
+extern void *memset(void *, int, size_t)
+    __attribute__((nonnull(1)));
+extern void *memcpy(void *, const void *, size_t)
+    __attribute__((nonnull(1, 2)));
+extern void *memmove(void *, const void *, size_t)
+    __attribute__((nonnull(1, 2)));
 
 
Index: uspace/lib/posix/source/signal.c
===================================================================
--- uspace/lib/posix/source/signal.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/posix/source/signal.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -382,5 +382,5 @@
  * Raise all unblocked previously queued signals.
  */
-static void _dequeue_unblocked_signals()
+static void _dequeue_unblocked_signals(void)
 {
 	link_t *iterator = _signal_queue.head.next;
Index: uspace/lib/usbdev/src/hub.c
===================================================================
--- uspace/lib/usbdev/src/hub.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/usbdev/src/hub.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -151,5 +151,5 @@
  * @retval EADDRNOTAVAIL Failed retrieving free address from host controller.
  * @retval EBUSY Failed reserving default USB address.
- * @retval ENOTCONN Problem connecting to the host controller via USB pipe.
+ * @retval ENXIO Problem connecting to the host controller via USB pipe.
  * @retval ESTALL Problem communication with device (either SET_ADDRESS
  *	request or requests for descriptors when creating match ids).
@@ -184,5 +184,5 @@
 	    &dev_conn, hc_conn, USB_ADDRESS_DEFAULT);
 	if (rc != EOK) {
-		rc = ENOTCONN;
+		rc = ENXIO;
 		goto leave_release_free_address;
 	}
@@ -192,5 +192,5 @@
 	rc = usb_pipe_initialize_default_control(&ctrl_pipe, &dev_conn);
 	if (rc != EOK) {
-		rc = ENOTCONN;
+		rc = ENXIO;
 		goto leave_release_free_address;
 	}
@@ -217,5 +217,5 @@
 	rc = usb_pipe_register(&ctrl_pipe, 0);
 	if (rc != EOK) {
-		rc = ENOTCONN;
+		rc = ENXIO;
 		goto leave_release_default_address;
 	}
@@ -278,5 +278,5 @@
 	if (rc != EOK) {
 		/* The child function is already created. */
-		rc = EDESTADDRREQ;
+		rc = EIO;
 		goto leave_release_free_address;
 	}
Index: uspace/srv/bd/sata_bd/sata_bd.c
===================================================================
--- uspace/srv/bd/sata_bd/sata_bd.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/bd/sata_bd/sata_bd.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -147,5 +147,5 @@
  *
  */
-static int get_sata_disks()
+static int get_sata_disks(void)
 {
 	devman_handle_t root_fun;
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/hid/remcons/remcons.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -44,7 +44,7 @@
 #include <fibril_synch.h>
 #include <task.h>
-#include <net/in.h>
-#include <net/inet.h>
-#include <net/socket.h>
+#include <inet/addr.h>
+#include <inet/endpoint.h>
+#include <inet/tcp.h>
 #include <io/console.h>
 #include <inttypes.h>
@@ -99,4 +99,14 @@
 };
 
+static void remcons_new_conn(tcp_listener_t *lst, tcp_conn_t *conn);
+
+static tcp_listen_cb_t listen_cb = {
+	.new_conn = remcons_new_conn
+};
+
+static tcp_cb_t conn_cb = {
+	.connected = NULL
+};
+
 static telnet_user_t *srv_to_user(con_srv_t *srv)
 {
@@ -111,6 +121,6 @@
 
 	/* Force character mode. */
-	send(user->socket, (void *)telnet_force_character_mode_command,
-	    telnet_force_character_mode_command_count, 0);
+	(void) tcp_conn_send(user->conn, (void *)telnet_force_character_mode_command,
+	    telnet_force_character_mode_command_count);
 
 	return EOK;
@@ -272,11 +282,20 @@
 }
 
-/** Fibril for each accepted socket.
- *
- * @param arg Corresponding @c telnet_user_t structure.
- */
-static int network_user_fibril(void *arg)
-{
-	telnet_user_t *user = arg;
+/** Handle network connection.
+ *
+ * @param lst  Listener
+ * @param conn Connection
+ */
+static void remcons_new_conn(tcp_listener_t *lst, tcp_conn_t *conn)
+{
+	telnet_user_t *user = telnet_user_create(conn);
+	assert(user);
+
+	con_srvs_init(&user->srvs);
+	user->srvs.ops = &con_ops;
+	user->srvs.sarg = user;
+	user->srvs.abort_timeout = 1000;
+
+	telnet_user_add(user);
 
 	int rc = loc_service_register(user->service_name, &user->service_id);
@@ -284,19 +303,19 @@
 		telnet_user_error(user, "Unable to register %s with loc: %s.",
 		    user->service_name, str_error(rc));
-		return EOK;
+		return;
 	}
 
 	telnet_user_log(user, "Service %s registerd with id %" PRIun ".",
 	    user->service_name, user->service_id);
-	
+
 	fid_t spawn_fibril = fibril_create(spawn_task_fibril, user);
 	assert(spawn_fibril);
 	fibril_add_ready(spawn_fibril);
-	
+
 	/* Wait for all clients to exit. */
 	fibril_mutex_lock(&user->guard);
 	while (!user_can_be_destroyed_no_lock(user)) {
 		if (user->task_finished) {
-			closesocket(user->socket);
+			user->conn = NULL;
 			user->socket_closed = true;
 			user->srvs.aborted = true;
@@ -310,5 +329,5 @@
 	}
 	fibril_mutex_unlock(&user->guard);
-	
+
 	rc = loc_service_unregister(user->service_id);
 	if (rc != EOK) {
@@ -320,82 +339,41 @@
 	telnet_user_log(user, "Destroying...");
 	telnet_user_destroy(user);
-
-	return EOK;
 }
 
 int main(int argc, char *argv[])
 {
-	int port = 2223;
-	
+	int rc;
+	tcp_listener_t *lst;
+	tcp_t *tcp;
+	inet_ep_t ep;
+
 	async_set_client_connection(client_connection);
-	int rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		fprintf(stderr, "%s: Unable to register server\n", NAME);
 		return rc;
 	}
-	
-	struct sockaddr_in addr;
-	
-	addr.sin_family = AF_INET;
-	addr.sin_port = htons(port);
-	
-	rc = inet_pton(AF_INET, "127.0.0.1", (void *)
-	    &addr.sin_addr.s_addr);
-	if (rc != EOK) {
-		fprintf(stderr, "Error parsing network address: %s.\n",
-		    str_error(rc));
-		return 2;
-	}
-
-	int listen_sd = socket(PF_INET, SOCK_STREAM, 0);
-	if (listen_sd < 0) {
-		fprintf(stderr, "Error creating listening socket: %s.\n",
-		    str_error(listen_sd));
-		return 3;
-	}
-
-	rc = bind(listen_sd, (struct sockaddr *) &addr, sizeof(addr));
-	if (rc != EOK) {
-		fprintf(stderr, "Error binding socket: %s.\n",
-		    str_error(rc));
-		return 4;
-	}
-
-	rc = listen(listen_sd, BACKLOG_SIZE);
-	if (rc != EOK) {
-		fprintf(stderr, "listen() failed: %s.\n", str_error(rc));
-		return 5;
+
+	rc = tcp_create(&tcp);
+	if (rc != EOK) {
+		fprintf(stderr, "%s: Error initializing TCP.\n", NAME);
+		return rc;
+	}
+
+	inet_ep_init(&ep);
+	ep.port = 2223;
+
+	rc = tcp_listener_create(tcp, &ep, &listen_cb, NULL, &conn_cb, NULL,
+	    &lst);
+	if (rc != EOK) {
+		fprintf(stderr, "%s: Error creating listener.\n", NAME);
+		return rc;
 	}
 
 	printf("%s: HelenOS Remote console service\n", NAME);
 	task_retval(0);
-
-	while (true) {
-		struct sockaddr_in raddr;
-		socklen_t raddr_len = sizeof(raddr);
-		int conn_sd = accept(listen_sd, (struct sockaddr *) &raddr,
-		    &raddr_len);
-
-		if (conn_sd < 0) {
-			fprintf(stderr, "accept() failed: %s.\n",
-			    str_error(rc));
-			continue;
-		}
-
-		telnet_user_t *user = telnet_user_create(conn_sd);
-		assert(user);
-
-		con_srvs_init(&user->srvs);
-		user->srvs.ops = &con_ops;
-		user->srvs.sarg = user;
-		user->srvs.abort_timeout = 1000;
-
-		telnet_user_add(user);
-
-		fid_t fid = fibril_create(network_user_fibril, user);
-		assert(fid);
-		fibril_add_ready(fid);
-	}
-
+	async_manager();
+
+	/* Not reached */
 	return 0;
 }
Index: uspace/srv/hid/remcons/remcons.h
===================================================================
--- uspace/srv/hid/remcons/remcons.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/hid/remcons/remcons.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -38,5 +38,4 @@
 #define NAME       "remcons"
 #define NAMESPACE  "term"
-#define BACKLOG_SIZE  5
 
 #endif
Index: uspace/srv/hid/remcons/user.c
===================================================================
--- uspace/srv/hid/remcons/user.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/hid/remcons/user.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -44,7 +44,5 @@
 #include <fibril_synch.h>
 #include <task.h>
-#include <net/in.h>
-#include <net/inet.h>
-#include <net/socket.h>
+#include <inet/tcp.h>
 #include <io/console.h>
 #include <inttypes.h>
@@ -58,8 +56,8 @@
 /** Create new telnet user.
  *
- * @param socket Socket the user communicates through.
+ * @param conn Incoming connection.
  * @return New telnet user or NULL when out of memory.
  */
-telnet_user_t *telnet_user_create(int socket)
+telnet_user_t *telnet_user_create(tcp_conn_t *conn)
 {
 	static int telnet_user_id_counter = 0;
@@ -78,5 +76,5 @@
 	}
 
-	user->socket = socket;
+	user->conn = conn;
 	user->service_id = (service_id_t) -1;
 	prodcons_initialize(&user->in_events);
@@ -193,13 +191,18 @@
 	/* No more buffered data? */
 	if (user->socket_buffer_len <= user->socket_buffer_pos) {
-		int recv_length = recv(user->socket, user->socket_buffer, BUFFER_SIZE, 0);
-		if ((recv_length == 0) || (recv_length == ENOTCONN)) {
+		int rc;
+		size_t recv_length;
+
+		rc = tcp_conn_recv_wait(user->conn, user->socket_buffer,
+		    BUFFER_SIZE, &recv_length);
+		if (rc != EOK)
+			return rc;
+
+		if (recv_length == 0) {
 			user->socket_closed = true;
 			user->srvs.aborted = true;
 			return ENOENT;
 		}
-		if (recv_length < 0) {
-			return recv_length;
-		}
+
 		user->socket_buffer_len = recv_length;
 		user->socket_buffer_pos = 0;
@@ -359,5 +362,5 @@
 
 
-	int rc = send(user->socket, converted, converted_size, 0);
+	int rc = tcp_conn_send(user->conn, converted, converted_size);
 	free(converted);
 
Index: uspace/srv/hid/remcons/user.h
===================================================================
--- uspace/srv/hid/remcons/user.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/hid/remcons/user.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -38,4 +38,5 @@
 #include <adt/prodcons.h>
 #include <fibril_synch.h>
+#include <inet/tcp.h>
 #include <inttypes.h>
 #include <io/con_srv.h>
@@ -51,6 +52,6 @@
 	/** Internal id, used for creating locfs entries. */
 	int id;
-	/** Associated socket. */
-	int socket;
+	/** Associated connection. */
+	tcp_conn_t *conn;
 	/** Location service id assigned to the virtual terminal. */
 	service_id_t service_id;
@@ -80,5 +81,5 @@
 } telnet_user_t;
 
-extern telnet_user_t *telnet_user_create(int);
+extern telnet_user_t *telnet_user_create(tcp_conn_t *);
 extern void telnet_user_add(telnet_user_t *);
 extern void telnet_user_destroy(telnet_user_t *);
Index: uspace/srv/hid/rfb/main.c
===================================================================
--- uspace/srv/hid/rfb/main.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/hid/rfb/main.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -150,12 +150,4 @@
 }
 
-static int socket_fibril(void *unused)
-{
-	rfb_accept(&rfb);
-	
-	/* Not reached */
-	return EOK;
-}
-
 int main(int argc, char **argv)
 {
@@ -267,12 +259,4 @@
 	}
 	
-	fid_t fib = fibril_create(socket_fibril, NULL);
-	if (!fib) {
-		fprintf(stderr, NAME ": Unable to create socket fibril.\n");
-		return 2;
-	}
-	
-	fibril_add_ready(fib);
-	
 	printf("%s: Accepting connections\n", NAME);
 	task_retval(0);
